<?php
// $Id $
function matching_nodes_service_by_fields(array $params) {
    $nids = false;
    foreach ($params AS $field_col => $value) {
        $field_parts = explode(':', $field_col);
        if (count($field_parts) != 2) {
            return services_error(t('Fields must be sent in field_name:column format'));
        }
        list($field, $col) = $field_parts;
        $field_def = content_fields($field);
        if (is_null($field_def)) {
            return services_error(t('No CCK field: ' . $field));
        }
        $db_info = content_database_info($field_def);
        if (!isset($db_info['columns'][$col])) {
            return services_error(t('No column: ' . $col));
        }
        $table = $db_info['table'];
        $column = $db_info['columns'][$col]['column'];
        
        
        $new_nids = array();
        $nid_res = db_query("SELECT nid FROM %s WHERE %s = '%s'", $table, $column, $value);
        while ($row = db_fetch_object($nid_res)) {
            $new_nids[] = $row->nid;
        }

	//	$new_nids contains all of the nids that match this $field => $value pair
	if ($nids === false) {    //  First run
	    $nids = $new_nids;
	} else {    //    need to check the intersection of the results
	    $nids = array_intersect($nids, $new_nids);
	}
    }
    $nodes = array();
    foreach ($nids AS $nid) {
	if (!$node = services_node_load(node_load(array('nid' => $nid)))) {
	    return services_error(t('Could not find the node.'));
	}
	$nodes[] = $node;
    }

    return $nodes;
}
function matching_nodes_service_get_access($params) {
    return user_access('Use Matching Service');
}
